package driveimageviewwrapper;

import ch.haclyon.driveimageview.DriveImageModel;
import ch.haclyon.driveimageview.DriveImageView;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.graphics.Color;
import android.graphics.Typeface;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;
import android.support.annotation.NonNull;
import android.widget.ImageView;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

//import butterknife.Bind;
//import butterknife.ButterKnife;

import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;


//@Events(values={"like_toggled"})
@Author("Github: Yannick Signer, Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("DriveImageView")
@DependsOn(values={"android-support-annotations"})
public class driveImageViewWrapper extends ViewWrapper<DriveImageView> implements DesignerCustomView {

	private BA ba;
	private String eventName;
        private DriveImageView cv;
        private DriveImageModel dim;
        public String ScaleTypeCentre = "CENTER";
        public String ScaleTypeCentreCrop = "CENTER_CROP";
        public String ScaleTypeCentreInside = "CENTER_INSIDE";
        public String ScaleTypeFitCentre = "FIT_CENTER";
        public String ScaleTypeFitEnd = "FIT_END";
        public String ScaleTypeFitStart = "FIT_START";
        public String ScaleTypeFitXY = "FIT_XY";
        public String ScaleTypeMatrix = "MATRIX";



	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new DriveImageView(ba.context);
                this.setObject(cv);
                addImage();
//              addListener();
//              addListener2();
 	}




//    @Hide
//    public void addListener(){

//        cv.setCallback(new LikeButtonView.Callback() {
//            @Override
//            public void like_toggled() {

//              if (ba.subExists(eventName + "_like_toggled")) {
//                ba.raiseEvent2(ba, false, eventName + "_like_toggled", true, new Object[0]);
//              }
//            }

//            @Override
//            public void progress_paused() {

//              if (ba.subExists(eventName + "_progress_paused")) {
//                ba.raiseEvent2(ba, false, eventName + "_progress_paused", true, new Object[0]);
//              }
//            }

//            @Override
//            public void progress_resumed() {

//              if (ba.subExists(eventName + "_progress_resumed")) {
//                ba.raiseEvent2(ba, false, eventName + "_progress_resumed", true, new Object[0]);
//              }
//            }


//        });
//    }


//      @Hide
//      public void addListener2(){
//        cv.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//              if (ba.subExists(eventName + "_button_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_button_clicked", true, new Object[0]);
//              }
//            }
//        });
//      }



    private void addImage() {
	       int DrawableID = BA.applicationContext.getResources().getIdentifier("placeholder", "drawable", BA.packageName);
//             cv.addImageFrame(DrawableID);
//	       Drawable drawable = BA.applicationContext.getResources().getDrawable(DrawableID);
//             cv.setDrawable(drawable); 
               cv.setDriveImageModel(new DriveImageModel("main text", "folder text", DrawableID));
    }


	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}


    
    /**
     * Sets the image bimap
     */
    public void setImageBitmap(Bitmap imageBitmap) {
        dim = cv.getDriveImageModel();
        dim.setImageBitmap(imageBitmap);
        cv.setDriveImageModel(dim);
        cv.invalidate();
    }


    private String MainText = "main text";
    /**
     * Sets the main text
     *
     */
    public void setMainText(String MainText) {
        dim = cv.getDriveImageModel();
        dim.setMainTitle(MainText);
        cv.setDriveImageModel(dim);
        cv.invalidate();
    }

    /**
     * Sets the image scale type
     */
    public void setImageScaleType(String scaletype) {
        if (scaletype == "CENTER")
          cv.setImageScaleType(ImageView.ScaleType.CENTER);
        if (scaletype == "CENTER_CROP")
          cv.setImageScaleType(ImageView.ScaleType.CENTER_CROP);
        if (scaletype == "CENTER_INSIDE")
          cv.setImageScaleType(ImageView.ScaleType.CENTER_INSIDE);
        if (scaletype == "FIT_CENTER")
          cv.setImageScaleType(ImageView.ScaleType.FIT_CENTER);
        if (scaletype == "FIT_END")
          cv.setImageScaleType(ImageView.ScaleType.FIT_END);
        if (scaletype == "FIT_START")
          cv.setImageScaleType(ImageView.ScaleType.FIT_START);
        if (scaletype == "FIT_XY")
          cv.setImageScaleType(ImageView.ScaleType.FIT_XY);
        if (scaletype == "MATRIX")
          cv.setImageScaleType(ImageView.ScaleType.MATRIX);
        cv.invalidate();
    }


    private String FolderText = "small text";
    /**
     * Sets the folder text
     *
     */
    public void setFolderText(String FolderText) {
        dim = cv.getDriveImageModel();
        dim.setFolderTitle(FolderText);
        cv.setDriveImageModel(dim);
        cv.invalidate();
    }


    /**
     * Sets the background-color of the main figure on the canvas.
     *
     */
    public void setBackgroundColor(String backgroundColor) {
        cv.setBackgroundColor(backgroundColor);
    }

    /**
     * Sets the background-color of the divider figure.
     *
     * @param divideColor the color as a Color-String. Using {@link android.graphics.Color#parseColor(String)}.
     */
    public void setDivideColor(String divideColor) {
        cv.setDivideColor(divideColor);
    }

    /**
     * Sets the text-color of both text's (main-text and folder-text)
     *
     * @param textColor the color as a Color-String. Using {@link android.graphics.Color#parseColor(String)}.
     */
    public void setTextColor(String textColor) {
        cv.setTextColor(textColor);
    }

    /**
     * Sets the opacity value of all the figures on the canvas.
     *
     * @param alphaValue the opacity (alpha) value in float, between 0f and 1f.
     */
//    public void setAlphaValue(float alphaValue) {
//        cv.setAlphaValue(alphaValue);
//        cv.invalidate();
//    }


    /**
     * This animates the text with a duration of 3 seconds.
     */
    public void animateText() {
        cv.animateText();
        cv.invalidate();
    }

    /**
     * This a animates a "blend-in" animation of the figure. The duration can be customised.
     *
     * @param duration The duration in milliseconds
     */
    public void setAnimateTextDuration(int duration) {
        cv.animateText(duration);
        cv.invalidate();
    }

    /**
     * Sets the custom height of the whole figure. This recalculates the text-sizes inside the Canvas.
     *
     * @param customHeight the desired height in dp.
     */
    public void setCustomHeight(float customHeight) {
        cv.setCustomHeight(customHeight);
        cv.invalidate();
    }

    /**
     * Sets the spacing between the left border of the DriveImageView and the crack before the folder-text.
     *
     * @param customFolderSpacing the desired spacing in dp.
     */
    public void setCustomFolderSpacing(float customFolderSpacing) {
        cv.setCustomFolderSpacing(customFolderSpacing);
        cv.invalidate();
    }


    /**
     * Sets the height and width of the folder corner.
     *
     * @param folderCorner height and width in dp.
     */
    public void setFolderCorner(float folderCorner) {
        cv.setFolderCorner(folderCorner);
        cv.invalidate();
    }








}
